/*-----------------------------------------------------------------------------

  Node.cpp
  SpinParserLib
  By Dave Fletcher
  (c) 2008 All Rights Reserved

  This code is released under the terms of the GNU Lesser General Public
  License (LGPL). See COPYING.

  INDUSTRIAL APPLICATION WARNING:
  Please note, this software is EXPERIMENTAL and is likely to remain in this
  state for a good while. Please do not use this software in mission critical
  applications and in situations where the safety of human-beings is at stake.

  This document is non-normative. It is not compared with the original Parallax
  documents or any Parallax source codes. It is derived mainly from the user
  manual and tests run inside the Propeller Tool.

  If you find bugs, the current place to report them is in the Parallax user
  forums. This may change in future:

    http://forums.parallax.com/forums/?f=25&m=253050&g=253340

-----------------------------------------------------------------------------*/

#include "Node.h"
#include "InvalidNode.h"

namespace SpinParser {

  StringPointer UNKNOWN_STRING = newStringPointer("UNKNOWN");

  Node::~Node(void) { ; }

  bool Node::hasChildren(void) {
    return (this->getChildCount() != 0);
  }

  size_t Node::getChildCount(void) {
    return 0;
  }

  Node::NodePointer Node::getChild(size_t index) {
    NodePointer p(new InvalidNode);
    return p;
  }

  StringPointer Node::getType(void) {
    return UNKNOWN_STRING;
  }

  StringPointer Node::getId(void) {
    // Perhaps the default auto-ID generator should live here.
    return UNKNOWN_STRING;
  }

  Node::NodeList Node::query(StringPointer query) {
    // This may take a whole other lexer / parser :)
	NodeList p;
	return p;
  }
}
